import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

public class ButtonPanel extends JPanel {
	
	ColorPanel colorPanel;
	Color PINK = new Color(223, 80, 193);
	Color ORANGE = new Color(247, 118, 19);
	Color GREEN = new Color(8, 180, 37);
	Color C1 = new Color(240, 241, 0);
	Color C2 = new Color(240, 239, 0);
	Color C3 = new Color(240, 242, 0);
	JButton Side1 = new JButton("Side 1");
   	JButton Side2 = new JButton("Side 2");
   	JButton Side3 = new JButton("Side 3");
   	boolean s1, s2, s3 = false;   	
   	int type = -1; // type of face that is selected
   	boolean showBox;
   	JCheckBox move = new JCheckBox("Allow movement");
   //	move.setMnemonic(KeyEvent.VK_m);
   // move.setSelected(true);
    
	   	
	public class newException extends Exception {
        public newException(String message) {
            super(message);
        }
    }
	   public ButtonPanel(ColorPanel colorPanel) {
		  this.colorPanel = colorPanel;
		  setLayout(new GridLayout(2,3)); 
		  this.setOpaque(true);
		  this.setBackground( colorPanel.background );
		  
	      JButton buttonI = new JButton("Titus I");
	      buttonI.setPreferredSize(new Dimension(80, 20));
	      buttonI.setForeground( new Color(0, 90, 250));
	      buttonI.setOpaque(true);
	      buttonI.setBackground( colorPanel.background );
	      add(buttonI);
	      buttonI.addActionListener( new ColorAction(C1) );
	      
	      JButton buttonII = new JButton("Titus II");
	      buttonII.setForeground( new Color(0, 90, 250));
	      buttonII.setOpaque(true);
	      buttonII.setBackground( colorPanel.background );
	      add(buttonII);
	      buttonII.addActionListener( new ColorAction(C2) );

	      JButton buttonIII = new JButton("Titus III");
	      buttonIII.setOpaque(true);
	      buttonIII.setBackground( colorPanel.background );
	      buttonIII.setForeground( new Color(0, 90, 250) );
	      add(buttonIII);
	      buttonIII.addActionListener( new ColorAction(C3) );
	      
	      JCheckBox move = new JCheckBox("Free Movement");
	      move.setOpaque(true);
	      move.setBackground( colorPanel.background);
	      move.setForeground( new Color(0, 170, 240) );
	      add(move);
	      move.addItemListener( new ItemListener() {
	    	  public void itemStateChanged(ItemEvent e) {
	    		  colorPanel.panel.allowMovement = ( e.getStateChange() == 1 ? true: false);
	    		  colorPanel.panel.repaint();
	    	  }
	      }
	      );
	      
	      JCheckBox pointNums = new JCheckBox("Point #'s");
	      pointNums.setOpaque(true);
	      pointNums.setBackground( colorPanel.background);
	      pointNums.setForeground( new Color(0, 170, 240) );
	      add(pointNums);
	      pointNums.addItemListener( new ItemListener() {
	    	  public void itemStateChanged(ItemEvent e) {
	    		  colorPanel.panel.showPointNums = ( e.getStateChange() == 1 ? true: false);
	    	//	  System.out.println("Show points is " + colorPanel.panel.showPointNums);
	    		  colorPanel.panel.repaint();
	    	  }
	      }
	      );
	      
	      JCheckBox faceColor = new JCheckBox("Colored Faces");
	      faceColor.setOpaque(true);
	      faceColor.setBackground( colorPanel.background);
	      faceColor.setForeground( new Color(0, 170, 240) );
	      add(faceColor);
	      faceColor.addItemListener( new ItemListener() {
	    	  public void itemStateChanged(ItemEvent e) {
	    		  colorPanel.panel.colorFaces = ( e.getStateChange() == 1 ? true: false);
	    	//	  System.out.println("Show points is " + colorPanel.panel.showPointNums);
	    		  colorPanel.panel.repaint();
	    	  }
	      }
	      );
	      //faceColor.doClick();
	      
	      
	      
	      Side1.addActionListener(new sideAction(0) );
		  Side1.setOpaque(true);
		  Side1.setBackground(Color.BLACK);
		  Side1.setForeground( PINK );
		  Side2.addActionListener(new sideAction(1) );
		  Side2.setOpaque(true);
		  Side2.setBackground(Color.BLACK);
		  Side2.setForeground( GREEN );
		  Side3.addActionListener(new sideAction(2) );
		  Side3.setOpaque(true);
		  Side3.setBackground(Color.BLACK);
		  Side3.setForeground( ORANGE );
	   }

	   // This private inner class is not visible outside ColorButtonPanel 
	   private class sideAction implements ActionListener {
		   
		   private int faceSide;
		   
		   public sideAction(int i) {
			   this.faceSide = i;
		   }
		   
		   public void actionPerformed(ActionEvent event) {
			   DrawingPanel panel = colorPanel.panel;
			   try {
				   if ( panel.selectedFace == null) {
					   throw new newException("Selected face is null. Cannot apply Titus move.");
				   }
			   }
			   catch(newException EE) {
				   System.err.println(EE);
				   return;
			   }
			   int selectedType = panel.selectedFace.getType();
			   
			   if ( selectedType == 1) {
				   panel.TitusI(panel.selectedFace);
			   }
			   else if ( selectedType == 2) {
				   if ( faceSide == 0) { // run Titus II about the UPPER half 
					   panel.TitusII(panel.selectedFace, true);
				   }
				   else if ( faceSide == 1 ) { // run Titus II about the LOWER half 
					   panel.TitusII(panel.selectedFace, false);
				   }
			   }
			   else if ( selectedType == 3) { // run the Titus III about the correct portion
				   if ( faceSide == 0 ) {
					   panel.TitusIII(panel.selectedFace, 0);
				   }
				   else if ( faceSide == 1 ) {
					   panel.TitusIII(panel.selectedFace, 1);
				   }
				   else if ( faceSide == 2 ) {
					   panel.TitusIII(panel.selectedFace, 2);
				   }
			   }
			   type = -1;
			   update();
		   }
	   }
	   
  	   private class ColorAction implements ActionListener {
 
	       private Color highlightColor;
	       
	       public ColorAction (Color C) {
	           this.highlightColor = C;
	       }

	       public void actionPerformed(ActionEvent event) {
	    	   DrawingPanel panel = colorPanel.panel;
	    	   if ( panel.complete ) {
	    		   colorPanel.remove(Side1); colorPanel.remove(Side2); colorPanel.remove(Side3);
	    		   
	    		   if ( highlightColor.equals(C1) ) {
	    			   colorPanel.highlightColor = C1;
	    			   colorPanel.highlightFaces = 1;
	    			   panel.highlightFaces = 1;
	    			   panel.highlightColor = C1;
	    			   update();
	    			   colorPanel.revalidate();
	    		   }
	    		   else if ( highlightColor.equals(C2) ) {
	    			   colorPanel.highlightColor = C2;
	    			   colorPanel.highlightFaces = 2;
	    			   panel.highlightFaces = 2;
	    			   panel.highlightColor = C2;
	    			   update();
	    			   colorPanel.revalidate();
	    		   }
	    		   else if ( highlightColor.equals(C3) ) {
	    			   colorPanel.highlightColor = C3;
	    			   colorPanel.highlightFaces = 3;
	    			   panel.highlightFaces = 3;
	    			   panel.highlightColor = C3;
	    			   update();
	    			   colorPanel.revalidate();
	    		   }
	    	   }
	    	   colorPanel.repaint();
	    	   panel.repaint();
	    	   repaint();
	       }
	   }
  	   
  	 public void update() {
  		 colorPanel.remove(Side1); colorPanel.remove(Side2); colorPanel.remove(Side3);
		 if ( type == 1) {
			 colorPanel.add(Side1);
		 }
		 else if ( type == 2) {
			 colorPanel.add(Side1);
			 colorPanel.add(Side2);
		 }
		 else if ( type == 3) {
			 colorPanel.add(Side1);
			 colorPanel.add(Side2);
			 colorPanel.add(Side3);
		 }
		 colorPanel.panel.repaint();
		 colorPanel.revalidate();
		 colorPanel.repaint();
		 repaint(); 
	 }
  	 
  	 protected void paintComponent(Graphics graphics){
  		   
	 } 

  	 
} // end of the class

